
define([
  'app',
  'models/model_user',
  'utils/toastUtil',
  'html/common/global_service',
  'html/common/service_user_info',
  'html/common/storage'
],function(app){
  app.controller('registerCtrl',
  ['$scope','$state','$ionicHistory','$timeout','userModel','ToastUtils','Global','userInfo','Storage','$ionicLoading',
  function ($scope, $state,$ionicHistory, $timeout,userModel,ToastUtils,Global,userInfo,Storage,$ionicLoading) {
      var token = '',platform = '';
      $scope.$on('$ionicView.beforeEnter', function(ev, data) {
          if(ionic.Platform.isWebView()){
              if(ionic.Platform.isWebView()) {
                  DMPush.get_device_token('test',function(device_token) {
                      token = device_token;
                  },function() {
                      
                  })
                  if(ionic.Platform.isAndroid()) {
                      platform = 'android'
                  } else if(ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
                      platform = 'ios'
                  }
              } 
          }
      })
    $scope.first = true;
    $scope.verifyBtnClickable = true;
    $scope.registerRequest = {
      password:'',
      invite_code:'',
      name:'',
      mcode:'',
      nick:'',
      icon:'',
      sex:1,
      token:token,
      platform:platform
    }

    initInviteCode() ;
    function initInviteCode(){
      var inviteCode = Global.getInviteCode();
      if(inviteCode==null || inviteCode=='' || angular.isUndefined(inviteCode)){
        $scope.registerRequest.invite_code = '' ;
      }else{
        $scope.registerRequest.invite_code = inviteCode ;
      }
    }
    $scope.isEnableNext = function(){
      return /^(13|18|15|14|17)\d{9}$/i.test($scope.registerRequest.name)
    };

    $scope.nextStep = function() {
      $scope.sendSmsVerificationCode()
    }

    $scope.clearPhone = function() {
      $scope.registerRequest.name = '';
    }

    var countdown = 60 ;//60 秒倒计时
    /**
     * 60秒倒计时函数
     */
    function setTimer() {
      if (countdown == 0) {
        $scope.verificationButtonText = "获取验证码";
        countdown = 60;
        $scope.verifyBtnClickable = true ;
      }else{
        $scope.verificationButtonText = "(" + countdown + "s)后重发";
        countdown -- ;
        $timeout(function() {
          setTimer()
        },1000);
      }
    }

    $scope.sendSmsVerificationCode = function (){
      if(!$scope.verifyBtnClickable){
        return ;
      }
      // if(!$scope.security.code) {
      //   ToastUtils.showWarning('获取手机验证码需要输入图形验证码');
      //   return;
      // }
      if($scope.registerRequest.name != ""){
        var number = $scope.registerRequest.name;
        $scope.registerRequest.mcode = '';
        userModel.getRegisterSms(number,'',onSuccess,onFail);
      }else{
        ToastUtils.showWarning('请先输入手机号！');
      }
    };

    function onSuccess(response){
      var code = response.data.code;
      var msg=response.data.msg;
      switch(code){
        case 0:
          ToastUtils.showSuccess(msg);
          $scope.verifyBtnClickable = false ;
          if($scope.first) $scope.first = false;
          setTimer();
          break;
        default :
          // $scope.security.params = baseApiUrl + "?c=user&a=code&t=" + (+new Date());
          // $scope.security.code = "";
          ToastUtils.showError(msg);
          break;
      }
    }

    function onFail(response){
      ToastUtils.showError('请检查网络状态，状态码：' + response.status);
    }

    $scope.isEnableRegister = function(){
      return ($scope.registerRequest.password.length >= 6) && ($scope.registerRequest.mcode.length > 0);
    };

     $scope.registerUser = function (){
      if($scope.isRegisterUser) return;
      $scope.isRegisterUser = true;
      showRegisteringDialog();
      $scope.registerRequest.nick = $scope.registerRequest.name.substr (0,3)  + '****' + $scope.registerRequest.name.substr (7,4)
      userModel.register($scope.registerRequest,onRegisterSuccess,onRegisterFail)

    };

    /**
     * 注册失败回调
     * @param response
     */
    function onRegisterFail(response){
      hideRegisteringDialog();
      ToastUtils.showError('请检查网络状态，状态码：' + response.status);
    }

    /**
     * 注册成功回调
     * @param response
     */
    function onRegisterSuccess(response){
      hideRegisteringDialog();
      var code = response.data.code;
      var msg = response.data.msg;
      var data = response.data.data;
      switch(code){
        case 0:
          ToastUtils.showSuccess(msg);
          userInfo.saveUserInfo(data);//保存用户信息
          Global.removeInviteCode();
          startToPage();
          break;
        default :
          $scope.isRegisterUser = false;
          ToastUtils.showError(msg);
          break;
      }
    }
    function startToPage() {
        var fromState = Storage.get('fromState')
        var fromParams = Storage.get('fromParams') || {};
        if(fromState) {
            $state.go(fromState,fromParams)
        } else {
            $state.go('tab.mainpage');
        } 
    }
    
    function showRegisteringDialog(){
      $ionicLoading.show({
        template: '正在注册...' + '<ion-spinner icon="android"></ion-spinner>',
        noBackdrop: true
      });
    }
    function hideRegisteringDialog(){
      $ionicLoading.hide();
    }

  }]);

});
