
define(
  [
    'app',
    'html/trolley/trolley_fly',
    'components/view-slidebox/view_slidebox',
    'components/view-grid/view_grid',
    'components/view-broad/view_broad',
    'utils/toastUtil',
    'models/model_activity',
    'components/view-progress/view_progress',
    'html/trolley/trolley_service',
    
    'html/common/storage',
    'components/view-countdown/view_countdown',
    'models/model_goods',
    'models/model_app',
  ],
  function(app,funParabola){
    'use strict';
    app
      .controller('MainPageController',['$scope','$state','ToastUtils','ActivityModel','AppModel','trolleyInfo','Storage','$timeout','$ionicSlideBoxDelegate','GoodsModel',
        function($scope,$state,ToastUtils,ActivityModel,AppModel,trolleyInfo,Storage,$timeout,$ionicSlideBoxDelegate,GoodsModel){
         
        getBanner();
        //获取广告图
        function getBanner() {
           ActivityModel.getBanner(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.slides = re.data;
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取广告图失败：' + '状态码：' + response.status);
          },null)
        }

                    function initGrids(flag) {
                        if (flag) {
                            $scope.grids = [{
                                    title: '商品分类',
                                    href: '#/classification',
                                    img: 'img/i1.png'
                                }, {
                                    title: '中奖晒单',
                                    href: '#/shareOrder/所有/所有/所有晒单',
                                    img: 'img/i3.png'
                                }, {
                                    title: '账户充值',
                                    href: '#/chongzhi',
                                    img: 'img/chongzhi.png'
                                },
                                {
                                    title: '常见问题',
                                    href: '#/question/question',
                                    img: 'img/q1.png'
                                }

                            ];
                        } else {
                            $scope.grids = [{
                                                title: '商品分类',
                                                href: '#/classification',
                                                img: 'img/i1.png'
                                            }, {
                                                title: '中奖晒单',
                                                href: '#/shareOrder/所有/所有/所有晒单',
                                                img: 'img/i3.png'
                                            }, {
                                                title: '10元专区',
                                                href: '#/tenYuan',
                                                img: 'img/t1.png'
                                            },
                                            {
                                                title: '常见问题',
                                                href: '#/question/question',
                                                img: 'img/q1.png'
                                            }

                                        ];
                        }
                    }
        
        
        //

       
      
        function initConfig() {
          $scope.isLoadFinished = true;
       

          getHomeNewPublish()
          getHotGoods()
          getShareOrderData()
         
        }
        
        $scope.doRefresh = function(){
          initConfig()
        };

        $scope.timeoutCallback = function(activity) {
          GoodsModel.getGoodsDetail(activity.activity_id,function(response, data) {
              if(data.code == 0) {
                var newActivity = data.data;
                if(newActivity.lucky_num) {
                    activity.status = newActivity.status;
                    activity.lucky_unick = newActivity.lucky_unick;
                    activity.lucky_num = newActivity.lucky_num;
                    activity.lucky_user_num = newActivity.lucky_user_num;
                    activity.lucky_ip = newActivity.lucky_ip;

                    if($scope.getHomeNewPublishTimeOut) $timeout.cancel($scope.getHomeNewPublishTimeOut);
                    $scope.getHomeNewPublishTimeOut = $timeout(function() {
                      $scope.getHomeNewPublishTimeOut = null;
                      getHomeNewPublish()
                    },10000)
                } else {
                  $scope.getGoodsTimeOut = $timeout(function() {
                      $scope.getGoodsTimeOut = null;
                      $scope.timeoutCallback(activity);
                  },1000);
                }
               
              }
          });
          
        };

            function getHomeNewPublish() {
                ActivityModel.getHomeNewPublish(function(xhr, re) {
                    var code = re.code;
                    if (code == 0) {
                        $scope.newPublish = re.data;
                    } else {
                        ToastUtils.showMsgWithCode(code, re.msg);
                    }
                }, function(response, data) {
                    ToastUtils.showMsgWithCode(7, '获取最新揭晓失败：' + '状态码：' + response.status);
                })
            }
        

        function getShareOrderData(){
          AppModel.getShare_list('time',1,0,function(response){
            var code = response.data.code ;
            var msg = response.data.msg ;
            switch (code){
              case 0 :
                var dataList = response.data.data ;
                var len = 3;
                if(dataList.length < 3 ) {
                  len = dataList.length
                }
                $scope.shareList = [];
                for(var i = 0;i < len;i++) {
                  $scope.shareList.push(dataList[i])
                }
                break;
              default :
                ToastUtils.showError(msg);
                break ;
            }
          },function(response){

          },function(){

          });
        }

        function getHotGoods() {
           ActivityModel.getHotGoods(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.hotGoods = re.data;
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取今日热门商品失败：' + '状态码：' + response.status);
          },function() {
            $scope.$broadcast('scroll.refreshComplete');
          })
       }

       
       
        $scope.getPercentageProgress = function(remain_num,need_num){
          var progress = (need_num - remain_num) * 100 / need_num;
          if(progress > 0 && progress < 1) progress = 1;
          return Math.floor(progress);
        };

        function addToCart(broad,$event){
          var img = new Image();
          img.src = broad.goods_img;
          img.style.display = 'none';
          img.className = 'eleFlyElement';
          img.style.top = $event.y + 'px';
          img.style.left = $event.x  + 'px';
          angular.element(document.body).append(img);
          img.style.display = 'block';
          var myParabola = funParabola(img, document.querySelector(".js-tab-cart"), {
            speed: 300, //抛物线速度
            curvature: 0.0008, //控制抛物线弧度
            complete: function() {
              img.style.display = 'none';
              angular.element(img).remove()
              var shopItem = broad;
              shopItem.join_number = 1;
              $scope.$apply(function() {
                trolleyInfo.addGoodsItem(shopItem);
              })
            }
          });

          myParabola.position().move(); 

          
        };

        $scope.addToCart = addToCart;
        $scope.goShareDetails = function(show_id) {
          $state.go('shareDetails',{
            show_id:show_id
          })
        }
       
         $scope.$on('$ionicView.beforeEnter', function(ev, data) {
            initConfig();
                        if (ionic.Platform.isWebView() && (ionic.Platform.isIOS() || ionic.Platform.isIPad())) {
                            var huixiao = Storage.get('huixiao');
                            if (huixiao && huixiao != 'huixiao') {
                                initGrids(true)
                            } else {
                                initGrids(false)
                            }
                        } else {
                            initGrids(true)
                        }
	           $timeout(function() {
              $ionicSlideBoxDelegate.next();
            },1000)
          })

        $scope.$on('$stateChangeStart', function() {
            if($scope.getGoodsTimeOut) $timeout.cancel($scope.getGoodsTimeOut);
            if($scope.getHomeNewPublishTimeOut) $timeout.cancel($scope.getHomeNewPublishTimeOut);
        });
        
    }]);
});

