/**
 * Created by Administrator on 2015/12/30.
 */
define(['app',
  'html/common/service_user_info',
  'models/model_user',
    'utils/toastUtil',
  'utils/exif',
  'utils/PhotoUtils',
  'html/common/storage'
  ], function(app){
    app.controller('AccountCtrl',
      ['$scope','$state','$ionicHistory','$ionicActionSheet','$ionicLoading','userInfo','userModel','ToastUtils','Storage','$ionicPopup',
        function($scope, $state,$ionicHistory,$ionicActionSheet,$ionicLoading,userInfo,userModel,ToastUtils,Storage,$ionicPopup){
          var sessId;
          $scope.$on('$ionicView.beforeEnter', function(ev, data) {
            //获取用户信息
            sessId = Storage.get("sessId");
           
            userInfo.requestInfo();
            getMyPoint()
            getInviteInfo()
                if(ionic.Platform.isWebView() && (ionic.Platform.isIOS() || ionic.Platform.isIPad())){
                    var huixiao = Storage.get('huixiao');
                    if(huixiao && huixiao == 'huixiao') {
                          $scope.showChongZhi = false;
                    } else {
                          $scope.showChongZhi = true;
                      
                    }
                } else {
                    $scope.showChongZhi = true;
                }
          })

          function getInviteInfo() {
              userModel.getInviteInfo(function(xhr, re) {
                  var code = re.code;
                  if (code == 0) {
                      var data = re.data;
                      $scope.inviteMoneyData = data;
                      sessionStorage.setItem('inviteMoney', data.money);
                  } else {
                      ToastUtils.showMsgWithCode(code, re.msg);
                  }
              }, function(response, data) {
                  ToastUtils.showMsgWithCode(7, '获取邀请好友数和佣金数失败：' + '状态码：' + response.status);
              }, function() {

              })
          }

          function getMyPoint() {
            userModel.getMyPoint(function(xhr, re) {
                if (re.code == 0) {
                    $scope.pointData = re.data || {point:0,total:0,use:0};
                    Storage.set('myPointData_' + sessId, $scope.pointData);
                } else {
                    ToastUtils.showError(re.msg);
                }
            }, function(xhr, re) {
                ToastUtils.showError(re.msg);
            })
          }
          
          /**
           * 获取当前用户信息
           * @returns {*}
           */
          $scope.getCurrUserInfo = function(){
            return userInfo.getUserInfo();
          };


            /**
             * 跳转到个人资料页面
             */
            $scope.startToUserDetail = function() {
                $state.go('userDetail');
            };


            $scope.call = function (phone) {
                if(ionic.Platform.isWebView()){
                    $ionicPopup.confirm({
                        content:'确定拨打电话:'+phone+'?',
                        scope: $scope,
                        buttons: [{
                            text: '确定',
                            onTap: function(e) {
                                phonedialer.dial(phone, function(err) {
                                });
                                return false;
                            }
                        },{
                            text: '取消',
                            onTap: function(e) {
                                return false;
                            }
                        }]
                    });


                }else{
                    window.location.href = 'tel:'+phone;
                }

            }

            /**
             * 跳转到邀请有礼页面
             */
            $scope.startToInvite = function() {
                $state.go('invite');
            };

            /**
             * 跳转到我的红包页面
             */
            $scope.startToRedPacket = function() {
                $state.go('redPacket');
                //$state.go('editShareOrder');
            };

            /**
             * 跳转到乐购记录页面
             */
            $scope.startToMyPartRecord = function() {
                $state.go('myIndianaRecord');
            };

            /**
             * 跳转到直购记录页面
             */
            $scope.startToMyDirectRecord = function() {
                $state.go('myDirectRecord');
            };

            /**
             * 跳转到设置页面
             */
            $scope.startToSetting = function(){
                $state.go('setting');
            };

            /**
             * 跳转到我的晒单页面
             */
            // console.log('ddddd'+userInfo.getUserInfo().uid)
            $scope.startToMyShareOrder = function() {
                $state.go('shareOrder', { uid: userInfo.getUserInfo().uid, goodsId: '', pageTitle: '我的晒单' });
            };

            /**
             * 跳转到中奖记录页面
             */
            $scope.startToWinningRecord = function() {
                $state.go('winningRecord');
            };

            $scope.goPre = function() {
                $state.go('tab.trolley');
            };

            $scope.goNews = function() {
                $state.go('myNews');
            };

            /**
             * 显示图片选择页面
             */
            $scope.showImageSelector = function() {
                if (navigator.camera) { //移动端
                    $ionicActionSheet.show({
                        titleText: '更换头像',
                        cancelText: '取消',
                        buttons: [{ text: '拍照' }, { text: '从相册中选取' }],
                        cancel: function() {
                            // add cancel code..
                        },
                        buttonClicked: function(index) {
                            switch (index) {
                                case 1: //选择本地图片
                                    PhotoUtils.getLocalPictureByApp(true, function(imageData) {
                                        showUploadingDialog();
                                        userModel.updateHeadIcon(imageData, uploadSuccess, uploadFail, null);
                                    }, function(errMsg) {
                                        //获取图片失败
                                        ToastUtils.showError(errMsg);
                                    });
                                    break;
                                case 0:
                                default: //拍照
                                    PhotoUtils.takePhotoByApp(true, function(imageData) {
                                        showUploadingDialog();
                                        userModel.updateHeadIcon(imageData, uploadSuccess, uploadFail, null);
                                    }, function(errMsg) {
                                        //获取图片失败
                                        ToastUtils.showError(errMsg);
                                    });
                                    break;
                            }
                            return true;
                        }
                    });

                } else { //浏览器
                    PhotoUtils.takePictureByHtml5(function(imageData) {
                        showUploadingDialog();
                        userModel.updateHeadIcon(imageData, uploadSuccess, uploadFail, null);
                    }, function(errMsg) {
                        //获取图片失败
                        ToastUtils.showError(errMsg);
                    });
                }
            };

            /**
             * 上传图片成功回调（用base64上传）
             * @param response
             * @param data
             * @param status
             * @param headers
             * @param config
             * @param statusText
             */
            function uploadSuccess(response, data, status, headers, config, statusText) {
                if (data.code === 0) {
                    hideUploadingDialog();
                    userInfo.updateHeadIcon(data.data.icon);
                } else {
                    hideUploadingDialog();
                }
            }

            /**
             * 上传图片失败回调（用base64上传）
             * @param response
             * @param data
             * @param status
             * @param headers
             * @param config
             * @param statusText
             */
            function uploadFail(response, data, status, headers, config, statusText) {
                hideUploadingDialog();
            }

            function showUploadingDialog() {
                $ionicLoading.show({
                    template: '上传中...' + '<ion-spinner icon="android"></ion-spinner>',
                    noBackdrop: true
                });
            }

            function hideUploadingDialog() {
                $ionicLoading.hide();
            }


        }]);

});
